function [ mcs ] = MeanCurvatureSignature( mesh, numTimes )
% This method computes the mean curvature descriptor for each vertex on a list.
% It uses precomputed LB eigenstuff stored in "mesh" and automatically
% chooses the time steps for the smoothing based on mesh geometry.

% % Same time steps as for HKS:
% tmin = -4*log(10)/mesh.eigenvalues(end);
% tmax = -4*log(10)/mesh.eigenvalues(10); % Why 10?
% ts = logspace(log10(tmin),log10(tmax),numTimes);

% % Diffusion in even steps between 0 and 1:
% ts = (1:(numTimes-1)) / (numTimes - 1);

ts = (1:(numTimes-1));

mcs = mean_curvature(mesh.vertices, mesh.triangles, mesh.cotLaplace, ts);

end

