function [F, D] = alternating_stabilization_area(W, M, S1, S2, area1, area2)
F = [];
D = [];
f_unstable = 1:size(W, 2);
d_unstable = 1:size(W, 1);

% S1.surface.X = shape1.M.vertices(:,1);
% S1.surface.Y = shape1.M.vertices(:,2);
% S1.surface.Z = shape1.M.vertices(:,3);
% S1.surface.TRIV = shape1.M.triangles;
% S1.surface.nv = shape1.M.num_vertices;
% S2.surface.X = shape2.M.vertices(:,1);
% S2.surface.Y = shape2.M.vertices(:,2);
% S2.surface.Z = shape2.M.vertices(:,3);
% S2.surface.TRIV = shape2.M.triangles;
% S2.surface.nv = shape2.M.num_vertices;

%area1 = shape1.M.barycentric_v_area;
%area2 = shape2.M.barycentric_v_area;
W_new = W;
M_new = M;

for i=1:9
    W_old = W_new;
    M_old = M_new;
    fo = ones(size(W,2),1);
    do = ones(size(W,1),1);
    a1 = 0.1;
    a2 = 0.1;
    if a1 >= a2
        [fo1, do1, ~] = alt_compute_stable_subspace_area(fo, W_old, M_old, area1, area2, f_unstable, d_unstable, a1);
    else [do1, fo1, ~] = alt_compute_stable_subspace_area(do, M_old, W_old, area2, area1, d_unstable, f_unstable, a2);
    end
    
    cc_f = function_components(S1, fo1);
    cc_d = function_components(S2, do1);
    for cc_counter=1:max(cc_f)
        a_ratio = sum(area1((cc_f == cc_counter)))/ sum(area1);
        if a_ratio < 0.01
            fo1(cc_f == cc_counter) = 0;
        end
    end
    for cc_counter=1:max(cc_d)
        a_ratio = sum(area2((cc_d == cc_counter)))/ sum(area2);
        if a_ratio < 0.01
            do1(cc_d == cc_counter) = 0;
        end
    end
    
    F = [F fo1];
    D = [D do1];
    W_new(:) = 0;
    M_new(:) = 0;
    f_stable = find(fo1==1);
    d_stable = find(do1==1);
    f_unstable = setdiff(f_unstable, f_stable);
    d_unstable = setdiff(d_unstable, d_stable);
    W_new(d_unstable, f_unstable) = W_old(d_unstable, f_unstable);
    M_new(f_unstable, d_unstable) = M_old(f_unstable, d_unstable);
    area1(f_stable) = 0;
    area2(d_stable) = 0;
    i
end
F = [F 1-sum(F,2)];
D = [D 1-sum(D,2)];
end