function [F, D] = stable_region_corrs(F1, S1, area1, F2, S2, area2, alg)
% alg = 1 for Algorithm 2 based on just equal area regions, and alg = 2 for
% Algorithm 3 based on natural learning of regions.
fprintf('Constructing the affinity matrix...\n');
W = matchvertices_char_function_fast(F1, F2);
fprintf('done constructing the affinity matrix.\n');
M = W';

fprintf('Computing the stable regions...\n');tic;
if (alg == 2)
    [F, D] = alternating_stabilization_area(W, M, S1, S2, area1, area2);
elseif (alg == 3)
        [F, D] = alternating_stabilization_1(W, M, S1, S2, area1, area2);
end;
fprintf('done.\n');toc;

end